package com.mdd.admin.service.impl;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONArray;
import com.alibaba.fastjson2.JSONReader;
import com.baomidou.mybatisplus.core.toolkit.Assert;
import com.mdd.admin.service.IChannelOaMenusService;
import com.mdd.common.exception.OperateException;
import com.mdd.common.plugin.wechat.WxMnpDriver;
import com.mdd.common.util.ConfigUtils;
import com.mdd.common.util.ListUtils;
import com.mdd.common.util.MapUtils;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import me.chanjar.weixin.common.bean.menu.WxMenu;
import me.chanjar.weixin.common.bean.menu.WxMenuButton;
import me.chanjar.weixin.common.error.WxErrorException;
import me.chanjar.weixin.mp.api.WxMpMenuService;
import me.chanjar.weixin.mp.api.WxMpService;
import me.chanjar.weixin.mp.api.impl.WxMpMenuServiceImpl;
import org.springframework.stereotype.Service;

@Service
public class ChannelOaMenusServiceImpl implements IChannelOaMenusService {
   public JSONArray detail() {
      String json = ConfigUtils.get("oa_channel", "menus", "[]");
      return JSONArray.parseArray(json, new JSONReader.Feature[0]);
   }

   public void save(List<Object> objs, Boolean isPublish) {
      if (objs.size() > 3) {
         throw new OperateException("一级菜单超出限制(最多3个)");
      } else {
         List<Map<String, String>> params = new LinkedList();
         Iterator var4 = objs.iterator();

         while(var4.hasNext()) {
            Object o = var4.next();
            params.add(MapUtils.objectToMap(o));
         }

         List<WxMenuButton> menuButtons = new LinkedList();
         Iterator var14 = params.iterator();

         while(true) {
            Map item;
            WxMenuButton wxMenuButton;
            do {
               if (!var14.hasNext()) {
                  ConfigUtils.set("oa_channel", "menus", JSON.toJSONString(objs));
                  if (isPublish) {
                     try {
                        WxMenu wxMenu = new WxMenu();
                        wxMenu.setButtons(menuButtons);
                        WxMpService wxMpService = WxMnpDriver.oa();
                        WxMpMenuService wxMpMenuService = new WxMpMenuServiceImpl(wxMpService);
                        wxMpMenuService.menuCreate(wxMenu);
                     } catch (WxErrorException var12) {
                        WxErrorException e = var12;
                        throw new OperateException(e.getError().getErrorCode() + ": " + e.getError().getErrorMsg());
                     }
                  }

                  return;
               }

               item = (Map)var14.next();
               Assert.notNull(item.get("name"), "一级菜单名称不能为空", new Object[0]);
               wxMenuButton = new WxMenuButton();
               wxMenuButton.setName((String)item.get("name"));
               if (Integer.parseInt((String)item.get("menuType")) == 1) {
                  Assert.notNull(item.get("visitType"), "一级菜单visitType数缺失", new Object[0]);
                  if (((String)item.get("visitType")).equals("miniprogram")) {
                     Assert.notNull(item.get("appId"), "一级菜单appId参数缺失", new Object[0]);
                     Assert.notNull(item.get("url"), "一级菜单url数缺失", new Object[0]);
                     Assert.notNull(item.get("pagePath"), "一级菜单pagePath数缺失", new Object[0]);
                     wxMenuButton.setType((String)item.get("visitType"));
                     wxMenuButton.setAppId((String)item.get("appId"));
                     wxMenuButton.setUrl((String)item.get("url"));
                     wxMenuButton.setPagePath((String)item.get("pagePath"));
                  } else {
                     Assert.notNull(item.get("url"), "一级菜单url数缺失", new Object[0]);
                     wxMenuButton.setType((String)item.get("visitType"));
                     wxMenuButton.setUrl((String)item.get("url"));
                     wxMenuButton.setAppId((String)item.getOrDefault("appId", ""));
                  }

                  menuButtons.add(wxMenuButton);
               }
            } while(Integer.parseInt((String)item.get("menuType")) != 2);

            Assert.notNull(item.get("subButtons"), "子级菜单不能为空", new Object[0]);
            List<Map<String, String>> subButtons = ListUtils.stringToListAsMapStr((String)item.get("subButtons"));
            if (subButtons.size() > 5) {
               throw new OperateException("子级菜单超出限制(最多5个)");
            }

            WxMenuButton subMenuButton;
            for(Iterator var9 = subButtons.iterator(); var9.hasNext(); menuButtons.add(subMenuButton)) {
               Map<String, String> subItem = (Map)var9.next();
               subMenuButton = new WxMenuButton();
               Assert.notNull(subItem.get("visitType"), "子级菜单visitType参数缺失!", new Object[0]);
               if (((String)subItem.get("visitType")).equals("miniprogram")) {
                  Assert.notNull(subItem.get("appId"), "子级菜单appId参数缺失!", new Object[0]);
                  Assert.notNull(subItem.get("url"), "子级菜单url数缺失!", new Object[0]);
                  Assert.notNull(subItem.get("pagePath"), "子级菜单pagePath数缺失!", new Object[0]);
                  wxMenuButton.setType((String)subItem.get("visitType"));
                  wxMenuButton.setAppId((String)subItem.get("appId"));
                  wxMenuButton.setUrl((String)subItem.get("url"));
                  wxMenuButton.setPagePath((String)subItem.get("pagePath"));
               } else {
                  Assert.notNull(subItem.get("url"), "子级菜单url数缺失", new Object[0]);
                  wxMenuButton.setType((String)subItem.get("visitType"));
                  wxMenuButton.setUrl((String)subItem.get("url"));
               }
            }
         }
      }
   }
}
